module Main where

import System.IO
import Graphics.UI.Gtk
import Core
import Reboot

import Manatee.Keymap.Keymap
import Manatee.UI.View
import Manatee.IORefObject

import qualified Graphics.UI.Gtk as G

main :: IO ()
main = do
  initGUI

  rebootState <- restoreState rebootDefaultState

  ioRefObject <- ioRefObjectNew 
  let rootWindow = ioRefObjectRootWindow ioRefObject
  rootWindow `onDestroy` mainQuit

  rootWindow `onKeyPress` (\event -> mainKeyPressHandler event ioRefObject)

  rebootRebuild rebootState ioRefObject

  viewInit ioRefObject

  widgetShowAll rootWindow

  mainGUI
