{-# LANGUAGE ExistentialQuantification, RankNTypes #-}
module Manatee.Keymap.Page where

import Control.Arrow

import {-# source #-} Manatee.Keymap.Keymap
import qualified Data.Map as M
import Manatee.PageView.PageView
import Manatee.UI.Page
import Manatee.IORefObject

data PageAction = PageAction (Page -> IORefObject -> IO ())

instance ActionExecute PageAction where
    execute (PageAction a) = pageApplyFocus a

data PageViewAction = PageViewAction (forall a . PageView a => a -> IO ())

instance ActionExecute PageViewAction where
    execute (PageViewAction a) = pageApplyFocusBuffer a

-- | Page keymap.
pageKeymap :: Keymap
pageKeymap = 
    M.fromList $ map (second (Action . PageAction))
         [("M-;",       pageRemove)]

-- | Page view keymap.
pageViewKeymap :: Keymap
pageViewKeymap = 
    M.fromList $ map (second (Action . PageViewAction))
         [("M-u",       pageViewScrollLineUp)
         ,("M-i",       pageViewScrollLineDown)
         ,("M-U",       pageViewScrollPageUp)
         ,("M-I",       pageViewScrollPageDown)
         ,("M-O",       pageViewBegin)
         ,("M-Y",       pageViewEnd)
         ,("M-b",       pageViewSwitchFocus)]

