module Manatee.Keymap.TabGroup where

import Control.Arrow

import {-# source #-} Manatee.Keymap.Keymap
import qualified Data.Map as M
import Manatee.UI.TabGroup
import Manatee.IORefObject

data TabGroupAction = TabGroupAction (TabGroup -> IORefObject -> IO ())

instance ActionExecute TabGroupAction where
    execute (TabGroupAction a) = tabGroupApplyFocus a

-- | TabGroup keymap.
tabGroupKeymap :: Keymap
tabGroupKeymap = 
    M.fromList $ map (second (Action . TabGroupAction))
         [("M-7",       tabGroupSelectPrevPage)
         ,("M-8",       tabGroupSelectNextPage)
         ,("M-&",       tabGroupSelectFirstPage)
         ,("M-*",       tabGroupSelectLastPage)
         ,("M-9",       tabGroupMovePageToLeft)
         ,("M-0",       tabGroupMovePageToRight)
         ,("M-(",       tabGroupMovePageToBegin)
         ,("M-)",       tabGroupMovePageToEnd)]
