module Manatee.Keymap.View where

import Control.Arrow

import Manatee.IORefObject
import Manatee.UI.View
import {-# source #-} Manatee.Keymap.Keymap

import qualified Data.Map as M

data ViewAction = ViewAction (View -> IORefObject -> IO ())

instance ActionExecute ViewAction where
    execute (ViewAction a) = viewApplyFocus a

data ViewListAction = ViewListAction (IORefObject -> IO ())

instance ActionExecute ViewListAction where
    execute (ViewListAction a) = a

-- | View keymap.
viewKeymap :: Keymap
viewKeymap = 
    M.fromList $ map (second (Action . ViewAction)) 
         [("M-t",       viewSplitVertically)
         ,("M-T",       viewSplitHortizontally)
         ,("M-'",       viewRemove)
         ,("M-\"",      viewRemoveOthers)] 

-- | View list keymap.
viewListKeymap :: Keymap
viewListKeymap =
    M.fromList $ map (second (Action . ViewListAction))
         [("M-3",       viewListNextCircular)
         ,("M-4",       viewListPrevCircular)
         ,("M-#",       viewListNext)
         ,("M-$",       viewListPrev)]
