{-# LANGUAGE ExistentialQuantification #-}
{-# LANGUAGE DeriveDataTypeable #-}
{-# LANGUAGE RankNTypes #-}
module Manatee.PageMode.PageMode where

import {-# source #-} Manatee.UI.Page
import {-# source #-} Manatee.Keymap.Keymap

data PageMode = forall syntax . PageMode (Mode syntax)

data Mode syntax = 
    Mode {modeName      :: String -- mode name
         ,modeRegexp    :: String -- regular expression for match file
         ,modeKeymap    :: Keymap -- local keymap
         ,modeLoad      :: Page -> IO () -- local mode load
         }

emptyMode :: Mode syntax
pageModeTable :: [PageMode]
pageModeLookup :: String -> PageMode
pageModeApply :: (forall syntax . Mode syntax -> b) -> PageMode -> b
pageModeLoad :: PageMode -> Page -> IO ()
