{-# LANGUAGE ExistentialQuantification, RankNTypes #-}
module Manatee.UI.Page where

import Data.IORef

import Graphics.UI.Gtk hiding (on, get)

import Manatee.Data.SetList
import {-# source #-} Manatee.IORefObject
import {-# source #-} Manatee.PageView.PageView

data Page
data PageInsertPosition = PStart | PEnd | PLeft | PRight
data PageOpenStyle = PForeground | PBackground

instance Eq Page where
instance Ord Page where
instance Show Page where

pageRemove :: Page -> IORefObject -> IO ()

type PageList = SetList Page

pageListNew :: IO (IORef PageList)
pageListGetCounter :: IORef PageList -> IO Int
pageListIncCounter :: IORef PageList -> IO ()
pageListGetNewId :: IORef PageList -> IO Int
pageListAddPage :: IORef PageList -> Page -> IO ()
pageListRemovePage :: IORef PageList -> Page -> IO ()
pageListGetList :: IORef PageList -> IO [Page]
pageListGetPage :: IORef PageList -> Int -> IO (Maybe Page)
pageClone :: Page -> IO Page
pageId :: Page -> Int
pageSetName :: Page -> String -> IO ()
pageApplyBuffer :: (forall a . PageView a => a -> b) -> Page -> b
pageBox :: Page -> VBox 
