module Manatee.UI.TabGroup where

import Graphics.UI.Gtk

import Data.IORef
import Data.Sequence (Seq)

import {-# source #-} Manatee.UI.Page
import {-# source #-} Manatee.IORefObject

data TabGroup 

tabGroupNew :: IORef PageList -> Maybe [Int] -> IO TabGroup
tabGroupAppendPage :: TabGroup -> PageInsertPosition -> Int -> Page -> IO ()
tabGroupInsertPage :: TabGroup -> Page -> Int  -> IO ()
tabGroupAppendPageList :: TabGroup -> IORef PageList -> Maybe [Int] -> IO ()
tabGroupAddPage :: TabGroup -> PageInsertPosition -> Int -> Page -> IO ()
tabGroupGetCurrentPage :: TabGroup -> IO (Maybe Page)
tabGroupSelectNextPage :: TabGroup -> IORefObject -> IO ()
tabGroupSelectPrevPage :: TabGroup -> IORefObject -> IO ()
tabGroupSelectFirstPage :: TabGroup -> IORefObject -> IO ()
tabGroupSelectLastPage :: TabGroup -> IORefObject -> IO ()
tabGroupSelectPage :: TabGroup -> Int -> IO ()
tabGroupAtStart :: TabGroup -> IO Bool
tabGroupAtEnd :: TabGroup -> IO Bool
tabGroupFirstIndex :: TabGroup -> IO Int
tabGroupLastIndex :: TabGroup -> IO Int
tabGroupCurrentIndex :: TabGroup -> IO Int
tabGroupSize :: TabGroup -> IO Int
tabGroupRemoveAllPage :: TabGroup -> IO ()
tabGroupRemovePage :: TabGroup -> Page -> IO ()
tabGroupGetPageSequnceId :: TabGroup -> Page -> IO (Maybe Int)
tabGroupGetPageSequncePage :: TabGroup -> Int -> IO (Maybe Page) 
tabGroupFocusPage :: TabGroup -> Page -> IO ()
tabGroupSetPageName :: TabGroup -> Page -> String -> IO ()
tabGroupPageIdSequence :: TabGroup -> IORef (Seq Int)
tabGroupNotebook :: TabGroup -> Notebook
