module Manatee.UI.View where

import Data.IORef

import {-# source #-} Manatee.UI.ViewNode
import {-# source #-} Manatee.UI.TabGroup
import {-# source #-} Manatee.UI.Page
import {-# source #-} Manatee.IORefObject

data View =
    View {viewNode     :: ViewNode
         ,viewTabGroup :: TabGroup}
-- data View 

instance Eq View where
instance Ord View where
instance Show View where

viewGetCurrentPageSequenceId :: View -> IO (Maybe Int)
viewFocusBuffer :: View -> IO ()
viewGetCurrentPage :: View -> IO (Maybe Page)
viewSplitVertically :: View -> IORefObject -> IO ()  
viewSplitHortizontally :: View -> IORefObject -> IO ()
viewRemove :: View -> IORefObject -> IO ()
viewRemoveOthers :: View -> IORefObject -> IO ()
viewApplyFocus :: (View -> IORefObject -> IO ()) -> IORefObject -> IO ()
viewApplyFocus' :: (View -> IO (Maybe a)) -> IORefObject -> IO (Maybe a)

data ViewList
data ViewListSelectDirection = VLeft | VRight 

viewListNew :: IO (IORef ViewList)
viewListGetFocusView :: IORef ViewList -> IO (Maybe View)
viewListAddView :: IORef ViewList -> View -> ViewNodeType -> IO ()
viewListRemoveView :: IORef ViewList -> IO ()
viewListShow :: IORefObject -> IO ()
viewListFocus :: IORef ViewList -> View -> IO ()
viewListSelect :: ViewListSelectDirection -> Bool -> IORef ViewList -> IO ()
viewListNext :: IORefObject -> IO ()
viewListPrev :: IORefObject -> IO ()
viewListNextCircular :: IORefObject -> IO ()
viewListPrevCircular :: IORefObject -> IO ()
viewListRemoveOthersView :: IORef ViewList -> IO ()
viewListSize :: IORef ViewList -> IO Int
viewListApplyView :: (View -> IO ()) -> IORefObject -> IO ()
viewHandleAction :: View -> IORef ViewList -> IO ()
viewNewInternal :: ViewNode -> Maybe View -> IORefObject -> IO View
