module Manatee.Utils.Set where

import Data.Set (Set)
import Control.Monad hiding (filterM, mapM)

import qualified Data.Set as Set
import qualified Control.Monad as CM

-- | Find min element match in Set.
maybeFindMin :: Ord a => Set a -> (a -> Bool) -> Maybe a
maybeFindMin s f 
    | Set.null set 
        = Nothing
    | otherwise    
        = Just $ Set.findMin set
    where
      set = Set.filter f s

-- | maybeFindMinM.
maybeFindMinM :: (Ord a, Monad m) => Set a -> (a -> m Bool) -> m (Maybe a)
maybeFindMinM s f = do
  set <- filterM f s
  return $
         if Set.null set
            then Nothing
            else Just $ Set.findMin set
  
-- | filterM for Data.Set.
filterM :: (Ord a, Monad m) => (a -> m Bool) -> Set a -> m (Set a)
filterM f xs = Set.fromList `liftM` CM.filterM f (Set.toList xs)

-- | mapM for Data.Set
mapM :: (Ord a, Ord b, Monad m) => (a -> m b) -> Set a -> m (Set b)
mapM f sa = Set.fromList `liftM` CM.mapM f (Set.toList sa)

